import string,shutil,os,math
import numpy,scipy,pylab
#import wafo.objects
import wafo.objects

def findrfc_wafo(x):
	## based on matlab wafo's tp2arfc4p and default values given in tp2rfc
	def_time=0.
	res0 = []
	T = len(x)
	ARFC = numpy.zeros((numpy.floor(T/2),2))
	N = -1
	
	res = numpy.zeros(max([200,len(res0)]))
	
	nres = -1
	
	for i in range(0,T):
		nres = nres+1
		res[nres] = x[i]
		cycleFound = 1
		while cycleFound ==1 and nres >=4:
			if res[nres-1] < res[nres-2]:
				A = [res[nres-1], res[nres-2]]
			else:
				A = [res[nres-2], res[nres-1]]
			
			if res[nres] < res[nres-3]:
				B = [res[nres], res[nres-3]]
			else:
				B = [res[nres-3], res[nres]]
			
			if A[0] >= B[0] and A[1] <= B[1]:
				N=N+1
				arfc = [[res[nres-2]],[res[nres-1]]]
				ARFC[N] = [res[nres-2],res[nres-1]] 
				res[nres-2] = res[nres]
				nres = nres-2
			else:
				cycleFound = 0
	## residual
	res = res[0:nres+1]
	
	def res2arfc(res):
		nres = len(res)
		ARFC = []
		if nres < 2:
			return
		## count min to max cycles, gives correct number of upcrossings
		if (res[1]-res[0])	> 0.:
			i_start = 0
		else:
			i_start=1
		I = range(i_start,nres-1,2)
		Ip1 = range(i_start+1,nres,2)
		## def_time = 0
		
		for ii in range(len(I)):
			ARFC.append( [res[I[ii]], res[Ip1[ii]]] )
			
		ARFC = numpy.array(ARFC)
	
		return ARFC
		
	ARFC_res = res2arfc(res)
	
	ARFC = numpy.concatenate((ARFC,ARFC_res))
	
	## make symmetric
	[N,M] = numpy.shape(ARFC)
	I = []
	J=0
	RFC = ARFC
	
	for ii in range(N):
		if ARFC[ii,0] > ARFC[ii,1]:
			## Swap variables
			RFC[ii,J],RFC[ii,J+1] = RFC[ii,J+1],RFC[ii,J]

	cc = RFC
	
	rfcamp = (RFC[:,1] - RFC[:,0])/2.
	
	return rfcamp

def fatiguedamage_oneslope(time,stress,m1,loga1,tref,kf,thk):
	## stress: stressvector, unit: Pa
	## m1, loga1, m2, loga2: Parameters from table 2.2 in RP-C203
	## tref, k: perameters from point 2.4 in RP-C203
	## th: structural detail thickness
	## Nbins: number of bins cycles are divided into
	## Calculates fatigue damage for bilinear SN curves for tubular joints
	## 
	stress = stress*1.E-6 # Input in MPa
	a1 = 10.**loga1
	Ka= 2.0**m1/a1*(thk/tref)**(kf*m1)
	Kfac = Ka
	#~ Kfac = Ka
	##
	timemat = numpy.column_stack((time,stress))
	ts = wafo.objects.mat2timeseries(timemat)
	tp = ts.turning_points(h=25.0)
	#~ mm = findrfc_wafo(tp.data) ## Rainflow cycles according to matlab wafo 
	mm = tp.cycle_pairs() ## min to max cycles

	bv = [m1]
	D = mm.damage(beta=bv, K = Kfac) ## needs to be modified for rainflow cycles
	D_T = D[0]

	return D_T
	


#~ def fatiguedamage(time,stress,m1,loga1,m2,loga2,tref,k,th,Nbins,hist=False, lab=''):
	#~ ## stress: stressvector, unit: Pa
	#~ ## m1, loga1, m2, loga2: Parameters from table 2.2 in RP-C203
	#~ ## tref, k: perameters from point 2.4 in RP-C203
	#~ ## th: structural detail thickness
	#~ ## Nbins: number of bins cycles are divided into
	#~ ## Calculates fatigue damage for bilinear SN curves for tubular joints
	#~ ## hist: true/false parameter, wether or not to plot histogram
	#~ timemat = numpy.column_stack((time,stress))
	#~ ts = wafo.objects.mat2timeseries(timemat)
	#~ tp = ts.turning_points()
	#~ mm = tp.cycle_pairs()
	#~ Nbins = len(mm.amplitudes())
	#~ [n_stress,DS] = numpy.histogram(2.0*mm.amplitudes(), bins=Nbins)
	#~ #[n_stress,DS] = numpy.histogram(mm.amplitudes(), bins=Nbins)
	#~ DS = numpy.delete(DS,0) #delete first elm
	#~ logN=loga2-m2*numpy.log10(DS*1e-6*(th/tref)**k) # tubular joint
	#~ for r in range(len(logN)):
		#~ Nr=10.0**logN[r]
		#~ if Nr<=10.0**6:
		    #~ logN[r]=loga1-m1*numpy.log10(DS[r]*1e-6*(th/tref)**k)
	#~ N_stress = 10.0**numpy.array(logN)
	#~ D_T=sum(n_stress/N_stress)
	
	#~ if hist:
		#~ pylab.hist(mm.amplitudes(), bins=Nbins,label=lab+' %.3e' %D_T)
		#~ pylab.ylabel(r'$N_{cycles}$')
		#~ pylab.xlabel(r'$\Delta\sigma$')
	
	#~ return D_T


def fatiguedamage_twoslope(time,stress,m1,loga1,m2,loga2,Nlim,th=25E-3,tref=25E-3,k=0.25):
	## stress: stressvector, unit: Pa
	## m1, loga1, m2, loga2: Parameters from table 2.2 in RP-C203, valid for MPa
	## tref, k: perameters from point 2.4 in RP-C203
	## th: structural detail thickness
	## Nbins: number of bins cycles are divided into
	## Calculates fatigue damage for bilinear SN curves for tubular joints
	## hist: true/false parameter, wether or not to plot histogram

	stress = stress*1.E-6
	timemat = numpy.column_stack((time,stress))
	ts = wafo.objects.mat2timeseries(timemat)
	tp = ts.turning_points()
	mm = findrfc_wafo(tp.data) ## Rainflow cycles according to matlab wafo 
	Nbins = len(mm)
	#~ mm = tp.cycle_pairs() ## min to max cycles
	#~ Nbins = len(mm.amplitudes())
	

	
	if th<tref:
		th = tref
	
	a1 = 10.**loga1
	K1 = 2.0**m1/a1*(th/tref)**(k*m1)
	beta1 = m1
	
	a2 = 10.**loga2
	K2 = 2.0**m2/a2*(th/tref)**(k*m2)
	beta2 = m2
	
	
	
	alim = (1.0/(K1*Nlim))**(1./m1)
	alim2 =  (1.0/(K2*Nlim))**(1./m2)
	
	#~ print 'alim = %.0f' %alim
	
	avalid = (1.0/(K2*1.0E7))**(1./m2)
	
	if not numpy.round(alim,0) == numpy.round(alim2,0):
		print loga1
		print loga2
		print m1
		print m2
		print K1
		print K2
		print alim
		print alim2
		print 'alim not the same as alim2, check SN curve values'
		
	key = False
	dd = 0.0
	#~ amp = abs(mm.amplitudes())
	amp = abs(mm)
	
	for aa in amp:
		if aa > alim:
			dd = dd + K1*aa**beta1
			#~ print 'N<1E6'
		elif aa <= alim:
			if aa < avalid:
				key = True
				#~ dd = dd + 0.0
				dd = dd + K2*aa**beta2
			else:
				dd = dd + K2*aa**beta2
				#~ print 'N>1E6'
		
	if key:
		a=0
		#~ print 'WARNING: Corresponding number of cycles for\n some stress ranges were outside of SN validity range'
	D_T = dd
	
	return D_T
	
	
def partial_fatiguedamage(time,stress,m1,loga1,m2,loga2,tref,k,th,Nbins,key):
	## stress: stressvector, unit: Pa
	## m1, loga1, m2, loga2: Parameters from table 2.2 in RP-C203
	## tref, k: perameters from point 2.4 in RP-C203
	## th: structural detail thickness
	## Nbins: number of bins cycles are divided into
	## Calculates fatigue damage for bilinear SN curves for tubular joints
	timemat = numpy.column_stack((time,stress))
	ts = wafo.objects.mat2timeseries(timemat)
	tp = ts.turning_points()
	mm = tp.cycle_pairs()
	[n_stress,DS] = numpy.histogram(2.0*mm.amplitudes(), bins=Nbins)
	#~ [n_stress,DS] = numpy.histogram(mm.amplitudes(), bins=Nbins)
	DS = numpy.delete(DS,0) #delete first elm
	logN=loga2-m2*numpy.log10(DS*1e-6*(th/tref)**k) # tubular joint
	for r in range(len(logN)):
		Nr=10.0**logN[r]
		if Nr<=10.0**6:
		    logN[r]=loga1-m1*numpy.log10(DS[r]*1e-6*(th/tref)**k)
	N_stress = 10.0**numpy.array(logN)
	D_T=n_stress/N_stress
	if key == 1:
		pylab.subplot(211)
		pylab.hist(2.0*mm.amplitudes()*1E-6, bins=Nbins)
		pylab.xlabel('Stress range [MPa]')
		pylab.ylabel('Number of cycles [-]')
		pylab.subplot(212)
		pylab.stem(DS*1E-6,D_T)
		pylab.xlabel('Stress range [MPa]')
		pylab.ylabel('Partial damage [-]')
		
	return [DS,D_T]
	
